
/*	File			CaseStudy_NotificationService_Client_CPPDlg.h
	Purpose			Notification Service Client
	Author			Richard Anthony	(R.J.Anthony@gre.ac.uk)
	Date			September 2014
*/

#pragma once
#include "NotificationServiceDeffinitions.h"
#include "afxwin.h"

// Timer events
#define  Client_WaitForMessageFrom_ENS_SERVER_Event	(UINT) 1
#define  Client_WaitForDirectoryServiceReply_Event	(UINT) 2
#define  DirectoryService_WaitForRequest_Event		(UINT) 2

class CCaseStudy_NotificationService_Consume_Client_CPPDlg : public CDialog
{
public:
	CCaseStudy_NotificationService_Consume_Client_CPPDlg(CWnd* pParent = NULL);
	virtual ~CCaseStudy_NotificationService_Consume_Client_CPPDlg();
	void Contact_DirectoryService();

	bool CreateResolveSocket();
	bool CreateApplicationSocket();
	void SetUpSendAddressStructForBroadcast(SOCKADDR_IN &Sockaddr_In, PORT port);
	IN_ADDR GetBroadcastAddress();
	IN_ADDR GetLocalHostAddressDetails();
	void SetUpLocalAddressStruct(SOCKADDR_IN &Sockaddr_In, PORT port);
	void SendResolveMessage();
	void ConnectToENS();
	void SendMessageToAppServer(EventNotificationService_Message_PDU ENS_Message);
	void InitiateTimer(UINT iEvent);
	void StopTimer(UINT iEvent);
	void OnTimer(UINT nIDEvent); 
	void SetUpSendAddress_to_EventNS(DirectoryServiceReply dsr);
	void ConnectionLost(int iError);

	enum { IDD = IDD_CASESTUDY_NOTIFICATIONSERVICE_CLIENT_CPP_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

private:
	CString m_csServerName;
	bool m_bConnected;
	bool m_bSubscribedToTemperatureEvent;
	bool m_bSubscribedToHumidityEvent;
		
	CListBox* m_pEventLogList;
	CButton* m_pRegisterForTempChangeButton;
	CButton* m_pRegisterForHumidityChangeButton;
	CEdit* m_pTemperatureEdit;
	CEdit* m_pHumidityEdit;
	
	UINT_PTR m_nTimer;				// Needed because receives are non-blocking

	SOCKET m_ResolveSock;			// UDP Socket on which 'Resolve' messages are sent and replies received
	SOCKET m_ApplicationSock;		// TCP Socket on which requests are sent to AppServers and on which replies are received
	
	SOCKADDR_IN m_ENS_Addr;			// Holds address for connecting to the ENS application server
	SOCKADDR_IN m_LocalAddr;		// Address for Receiving client requests
	SOCKADDR_IN m_RecvAddr;			// Address struct to hold address returned by recvfrom
	SOCKADDR_IN m_ResolveAddr;		// for Broadcasting 'register' messages to the Directory server
public:
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedRegisterforTempChange();
	afx_msg void OnBnClickedRegisterforHumidityChange();

	afx_msg void OnBnClicked_ClearEventLog_Button();
};
