/*	File			NotificationServiceDeffinitions.h
	Purpose			Deffinitions of key values used in the Notification Service
	Author			Richard Anthony	(R.J.Anthony@gre.ac.uk)
	Date			September 2014
*/
#pragma once
#define PORT unsigned short
#define EVENT_NOTIFICATION_SERVER_NAME "Event_NS"		// Event Notification Server
#define MAX_EVENT_TYPE_NAME_LENGTH 50
#define MAX_EVENT_VALUE_LENGTH 50


#define From_DIRECTORY_SERVICE_PORT	(u_int) 8002		// Fixed, defined by Directory Service
#define ENS_APPLICATION_PORT		(u_int) 8003		// TCP, ENS_Server Binds to this port
#define To_DIRECTORY_SERVICE_PORT	(u_int) 8008		// Fixed, defined by Directory Service

struct DirectoryServiceReply {                          // Fixed, defined by Directory Service
	// IP address followed by port
	unsigned char a1;
	unsigned char a2;
	unsigned char a3;
	unsigned char a4;
	unsigned int iPort;
	};

enum EventNotificationService_Message_Type {SubscribeToEvent, UnSubscribeToEvent, PublishEvent, EventUpdate};

struct EventNotificationService_Message_PDU {
	byte iMessageType;
	char cEventType[MAX_EVENT_TYPE_NAME_LENGTH];
	char cEventValue[MAX_EVENT_VALUE_LENGTH];	// Not valid in Subscribe messages
	SOCKADDR_IN SendersAddress;
};