/*	File			CaseStudy_TimeServiceClient_GUIDlg.h
	Purpose			Network Time Protocol (NTP) Client header code
	Author			Richard Anthony	(ar26@gre.ac.uk)
	Date			September 2014
*/

#pragma once
#define NTP_Port 123
#define NTP_PACKET_SIZE 48		// NTP time stamp is in the first 48 bytes of the message

class CCaseStudy_TimeServiceClient_GUIDlg : public CDialog
{
	byte SendPacketBuffer[NTP_PACKET_SIZE];		//buffer to hold outgoing packets (NTP service requests)
	byte ReceivePacketBuffer[NTP_PACKET_SIZE];	//buffer to hold incoming packets (UTC time value)
	
public:
	CCaseStudy_TimeServiceClient_GUIDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CCaseStudy_TimeServiceClient_GUIDlg();
	IN_ADDR GetConnectAddress();
	void InitiateTimer();
	void StopTimer();
	void OnTimer(UINT nIDEvent); 
	bool Receive();
	void StartPeriodic_NTP_requests();
	void StopPeriodic_NTP_requests();
	void Populate_NTP_Server_List();

	in_addr ResolveURLtoIPaddress(CString cStrURL);
	void SetUp_TimeService_AddressStruct(CString cStrURL);
	bool Send_TimeService_Request();

	bool CreateSocket(SOCKET* sock);
	bool SetSocketToNonBlockingMode(SOCKET* sock);
	void UpdateStatisticsDisplay();

	enum { IDD = IDD_CASESTUDY_TIMESERVICECLIENT_GUI_DIALOG };

	CEdit* m_pNTP_Address_1;
	CEdit* m_pNTP_Address_2;
	CEdit* m_pNTP_Address_3;
	CEdit* m_pNTP_Address_4;
	CEdit* m_pNTP_PORT;
	CEdit* m_pSelectedURL;
	CEdit* m_pUTC_Time;
	CEdit* m_pSecondsSince1900;
	CEdit* m_pNumNTPRequestsSent;
	CEdit* m_pNumNTPResponsesReceived;
	CButton* m_pNTP_StartButton;
	CListBox* m_pNTP_URL_List;
	CListBox* m_pNTP_Location_List;

private:
	bool m_bNTP_Client_Started;

	SOCKET m_TimeService_Socket;
	SOCKADDR_IN m_TimeService_SockAddr;
	int m_iSendLen;
	int m_iReceiveLen;
	int m_iNumRequestsSent;
	int m_iNumResponsesReceived;

	UINT_PTR m_nTimer;
	int m_iDelay;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedNtpStartButton();
	afx_msg void OnLbnSelchangeNtpServerUrlList();
	afx_msg void OnBnClickedCancel();
};

